/* tnt: Hostmode Terminal for TNC
   Copyright (C) 1993,1994 by Mark Wahl
   For license details see documentation
   include file for interface (ifacedef.h)
   created: Mark Wahl DL4YBG 94/11/27
   updated: Mark Wahl DL4YBG 94/11/27
*/

#define HEAD_LEN sizeof(IFACE_HEADER)
#define IFACE_PACLEN 256
#define MAX_LEN (HEAD_LEN + IFACE_PACLEN)

typedef struct iface_header{
  char indicator;
  short channel;
  short usernr;
  unsigned short len;
} IFACE_HEADER;


#define LEN_SIMPLE sizeof(int)
#define LEN_CSTATUS (LEN_SIMPLE + sizeof(int))
#define LEN_BOXPBOXSF (LEN_SIMPLE + sizeof(int))
#define LEN_BOXPABORTSF (LEN_SIMPLE + sizeof(int))

typedef struct iface_cmdbuf{
  int command;
  union {
    /* CMD_CSTATUS */
    int snd_frames;
    /* CMD BOXPBOXSF */
    struct {
      int timeout;
      char buffer[256-LEN_BOXPBOXSF];
    } boxpboxsf;
    /* CMD_BOXPABORTSF */
    int immediate;
    /* GENERAL */
    char buffer[256-LEN_SIMPLE];
  } data;
} IFACE_CMDBUF;


#define BLOCKING_SIZE 2048

struct queue_entry {
  char *buffer;
  int len;
  struct queue_entry *next;
};

/* special definitions */
#define NO_CHANNEL -1
#define NO_USERNR -1

/* states for iface_list.active (0 = inactive) */
#define IF_ACTIVE 1
#define IF_LISTENING 2

/* states of iface_list.indicator and first byte of iface-packet */
#define IF_COMMAND 1
#define IF_DATA 2
#define IF_UNPROTO 3

/* commands if IF_COMMAND */
#define CMD_ACTIVATE 1
#define CMD_DEACTIVATE 2
#define CMD_CONNECT 3
#define CMD_DISCONNECT 4
#define CMD_FINISH 5
#define CMD_CSTATUS 6
#define CMD_BLOCK 7
#define CMD_UNBLOCK 8
#define CMD_SORT_NEW_MAIL 9
#define CMD_SF_RX_EMT 10
#define CMD_BOXPBOXSF 11
#define CMD_BOXPRDISC 12
#define CMD_BOXPABORTSF 13
#define CMD_ABORT_ROUTING 14
#define CMD_START_SF 15
#define CMD_FINISH_PRG 16
#define CMD_ACT_RESP 17
