/* tnt: Hostmode Terminal for TNC
   Copyright (C) 1993-1995 by Mark Wahl
   For license details see documentation
   Procedures for remote (remote.c)
   created: Mark Wahl DL4YBG 94/01/16
   updated: Mark Wahl DL4YBG 95/01/05
*/

#include "tnt.h"
#include "macro.h"

extern struct channel_stat ch_stat[CHANNELS];
extern char rem_ver_str[];
extern struct tx_file tx_file[CHANNELS];
extern struct rx_file rx_file[CHANNELS];
extern int remote_flag;
extern int cookie_flag;
extern int ctext_flag;
extern int autobin_flag;
extern char tnt_ctextfile[];
extern char name_file_name[];
extern char news_file_name[];
extern char run_dir[];
extern char macrotext_dir[];
extern char ok_text[];
extern char download_dir[];

char rem_tnt_str[80];
char rem_inv_str[80];
char rem_newlin_str[80];
char rem_info_file[80];
char rem_help_file[80];
char rem_dis_str[80];
char rem_cls_str[80];
char rem_brk_str[80];
char rem_wri_str[80];
char rem_nodir_str[80];
char rem_error_str[80];
char rem_nocook_str[80];
char rem_name_err[80];
char rem_name_str1[80];
char rem_name_str2[80];
char tnt_dir[80];
char remote_dir[80];
char ctext_dir[80];
char abin_start_txt[80];

static void rem_echo();
static void rem_version();
void rem_time();
static void rem_disc();
static void rem_info();
static void rem_help();
void rem_dir();
static void rem_free();
void rem_cookie();
extern void open_sendfile();
extern void open_logfile();
extern void close_file();
extern void break_send();
extern void cmd_shell();
extern void cmd_run();
#ifdef TNT_CHAMBER
extern void cmd_frontend();
#endif
void rem_name();
static void rem_news();
#ifdef USE_IFACE
extern void cmd_box();
#endif

static struct com_list remote_list[] = {
  {"VERSION" ,1,1,rem_version,"",0,0},
  {"ECHO"    ,1,1,rem_echo,"",0,0},
  {"TIME"    ,1,1,rem_time,"",0,0},
  {"READ"    ,1,1,open_sendfile,"",TX_PLAIN,0},
  {"RPRG"    ,2,1,open_sendfile,"",TX_ABIN,0},
  {"WRITE"   ,1,2,open_logfile,"",RX_PLAIN,RX_RCV},
  {"WPRG"    ,2,2,open_logfile,"",RX_ABIN,RX_RCV},
  {"CLOSE"   ,2,1,close_file,"",0,0},
  {"BREAK"   ,2,1,break_send,"",0,0},
  {"DISCONNE",1,1,rem_disc,"",0,0},
  {"QUIT"    ,1,1,rem_disc,"",0,0},
  {"INFO"    ,1,1,rem_info,"",0,0},
  {"HELP"    ,1,1,rem_help,"",0,0},
  {"CAT"     ,3,1,rem_dir,"",1,0},
  {"DIR"     ,3,1,rem_dir,"",0,0},
  {"DIRLONG" ,4,1,rem_dir,"",1,0},
  {"FREE"    ,3,1,rem_free,"",0,0},
  {"COOKIE"  ,4,1,rem_cookie,"",0,0},
  {"SHELL"   ,2,1,cmd_shell,"",0,0},
  {"NAME"    ,1,1,rem_name,"",0,0},
  {"NEWS"    ,4,1,rem_news,"",0,0},
  {"RUN"     ,3,1,cmd_run,"",0,0},
  {"RUNT"    ,4,1,cmd_run,"",1,0},
#ifdef USE_IFACE  
  {"BOX"     ,2,1,cmd_box,"",0,0},
#endif
  {""        ,0,-1,NULL,"",0,0}
};

void init_remote()
{
  remote_flag = 1;
  cookie_flag = 1;
  ctext_flag = 0;
  autobin_flag = 1;
#ifdef TNT_CHAMBER
  strcpy(rem_tnt_str,"<chamber>: ");
#else
  strcpy(rem_tnt_str,"<TNT>: ");
#endif
  strcpy(rem_inv_str,"Invalid command !");
  strcpy(rem_newlin_str,"\015");
  strcpy(rem_dis_str,"\01573!\015");
  strcpy(rem_cls_str,"File closed");
  strcpy(rem_brk_str,"Transmission aborted");
  strcpy(rem_wri_str,"File open, end with //close");
  strcpy(rem_nodir_str,"No such file or directory or no permission");
  strcpy(rem_error_str,"Function not successful");
  strcpy(rem_nocook_str,"Cookie-file not existing");
  strcpy(rem_name_err,"Error writing to names-file");
  strcpy(rem_name_str1,"Thanks, ");
  strcpy(rem_name_str2,", your name has been stored");
  strcpy(abin_start_txt,"AutoBIN-receive started, filename: ");
}

/* check packet, if special strings are contained */
int check_spec_strings(channel,buffer)
int channel;
char *buffer;
{
  char strbuf[257];
  char buffer2[256];
  char date_str[257];
  char filename[257];
  char reststring[257];
  char *restptr;
  int buflen;
  int wait_bin;
  int start_bin;
  char *begin;
  char *lineend;
  int start_next_packet;
  int length;
  int umw;
  char tmpstr[10];
  int flag;
  char *ptr;
  char *ptr1;
  char *ptr2;
  char file_str[256];
  int i;
  int fd;
  int display;
  
#ifdef USE_IFACE
  if (iface_active(channel)) return(0);  
#endif
  display = 0;
  wait_bin = ((rx_file[channel].type == RX_ABIN) ||
              (rx_file[channel].type == RX_ABIN_Q)) && 
             (rx_file[channel].wait_bin);
  start_bin = (rx_file[channel].type == -1) && (autobin_flag);
  if (wait_bin || start_bin) {
    buflen = (*buffer) + 1;
    memcpy(strbuf,buffer+1,buflen);
    strbuf[buflen] = '\0';

    if ((begin = strstr(strbuf,"#BIN#")) == NULL)
      umw = 0; 
    else {
      umw = sscanf(begin,"#BIN#%d#|%d#$%s",&rx_file[channel].len,
                                           &rx_file[channel].crc,
                                           reststring);
      if (umw == 3) {
        if ((restptr = strchr(reststring,'#')) != NULL) {
          strncpy(date_str,reststring,restptr-reststring);
          date_str[restptr-reststring] = '\0';
          strcpy(filename,restptr+1);
          if (filename[0] != '\0') 
            umw = 4;
        }
        else {
          strcpy(date_str,reststring);
        }
      }
      start_next_packet = 1;
      length = 0;
      if ((lineend = strchr(begin,CR)) != NULL) {
        lineend++;
        if (lineend != &strbuf[buflen]) {
          start_next_packet = 0;
          length = buflen - (lineend - strbuf);
        }
      }
      if ((start_bin) && umw) {
        /* try to open file with received name */
        if (umw != 4) {
          strcpy(filename,download_dir);
          strcat(filename,"abinXXXXXX");
          mktemp(filename);
          ptr = strrchr(filename,'/') + 1;
        }
        else {
          for (i=0;i<strlen(filename);i++) {
            filename[i] = tolower(filename[i]);
          }
          ptr1 = strrchr(filename,'\\');
          ptr2 = strrchr(filename,'/');
          if ((ptr1 == NULL) && (ptr2 == NULL)) ptr = filename;
          else if (ptr1 == NULL) ptr = ptr2 + 1;
          else if (ptr2 == NULL) ptr = ptr1 + 1;
          else if (ptr1 > ptr2) ptr = ptr1 + 1;
          else ptr = ptr2 + 1;
          strcpy(file_str,download_dir);
          strcat(file_str,ptr);
          if ((fd = open(file_str,O_RDONLY)) != -1) {
            strcpy(filename,download_dir);
            strcat(filename,"abinXXXXXX");
            mktemp(filename);
            ptr = strrchr(filename,'/') + 1;
          }
        }
        open_logfile(RX_ABIN_Q,RX_RCV,channel,strlen(ptr),M_CONNECT,ptr);
        strcpy(file_str,abin_start_txt);
        strcat(file_str,ptr);
        strcat(file_str,rem_newlin_str);
        display = 1;
      }
      if (umw > 2) umw = 2;
    } 
    switch (umw) {
    case 1:
      rx_file[channel].crc = 0;
    case 2:
      rx_file[channel].crc_tmp = 0;
      rx_file[channel].len_tmp = 0;
      rx_file[channel].wait_bin = 0;
      flag = 0;
      rx_file[channel].start_time = time(NULL);
      memcpy(buffer2,buffer,256);
      *buffer2 = buflen - length - 1;
      data_display_len2(channel,buffer2);
      if (display)
        rem_data_display(channel,file_str);
      strcpy(tmpstr,"#OK#\015");
      rem_data_display(channel,tmpstr);
      queue_cmd_data(channel,X_DATA,strlen(tmpstr),flag,tmpstr);
      if (!start_next_packet)
        write_file(channel,length,RX_RCV,lineend);
      return(1);
    default:
      if (wait_bin) {
        if (strstr(strbuf,"#ABORT#") != NULL) {
          close_rxfile2(channel,0,1);
          cmd_display(M_REMOTE,channel,"AutoBIN-receive aborted",1);
        }
      }
    }
  }
  return(0);
}


/* analyse remote-input-string */
/* if result != 0 the string must not be written to a file */
int remote_input(channel,buffer)
int channel;
char *buffer;
{
  int len;
  int found;
  char com_string[9];
  int i,j;
  int invalid;
  char strbuf[257];
  char *str;
  int flag;
  int result;
  char rem_buffer[257];
  int rem_len;
  int rem_valid;
  int rem_end;
  char *ptr;
  char *ptr1;
  char *ptr2;
  int cpy_len;
  
  /* no remote if autobin-send */
  if (tx_file[channel].type == TX_ABIN) {
    if (tx_file[channel].wait_ok) {
      if (((*buffer)+1) >= 4) {
        if (strstr(buffer+1,"#OK#") != NULL) {
          tx_file[channel].wait_ok = 0;
          tx_file[channel].start_time = time(NULL);
          return(0);
        }
      }
    }
    if (((*buffer)+1) >= 7) {
      if (strstr(buffer+1,"#ABORT#") != NULL) {
        close_txfile(channel,0);
        cmd_display(M_REMOTE,channel,"AutoBIN-send aborted",1);
        return(0);
      }
    }
    return(0);
  }
  /* no remote if autobin-receive */
  if ((rx_file[channel].type == RX_ABIN) ||
      (rx_file[channel].type == RX_ABIN_Q)) {
    return(0);
  }
  if (shell_active(channel)) return(0);
#ifdef USE_IFACE
  if (iface_active(channel)) return(0);
#endif
  if (!remote_flag) return(0);
  result = 0;
  /* find remote commands (beginning with '//') */
  rem_len = (*buffer)+1;
  memcpy(rem_buffer,buffer+1,rem_len);
  rem_buffer[rem_len] = '\0';
  ptr2 = rem_buffer;
  rem_end = 0;
  while (!rem_end) {
    if (((ptr = strstr(ptr2,"//")) == NULL) ||
        (ch_stat[channel].state < 4)) {
      rem_end = 1;
      continue;
    }
    rem_valid = 0;
    if (ptr == rem_buffer) {
      if (ch_stat[channel].lastcr)
        rem_valid = 1;
    }
    else {
      if ((*(ptr - 1)) == '\015')
        rem_valid = 1;  
    }
    if (!rem_valid) {
      ptr2 = ptr + 2;
      continue;
    }
    /* copy command after // up to next cr */
    ptr += 2;
    ptr1 = strchr(ptr,'\015');
    if (ptr1 == NULL) {
      ptr1 = rem_buffer + rem_len;
    }
    ptr2 = ptr1;
    cpy_len = ptr1 - ptr;
    str = strbuf;
    strncpy(str,ptr,cpy_len);
    str[cpy_len] = '\0';
    invalid = 0;
    i = 0;
    len = strlen(str);
    while ((i < 8) && (i < len) && (*str != SPACE)) {
      com_string[i] = *str++;
      if ((com_string[i] > 0x60) && (com_string[i] < 0x7E))
        com_string[i] &= 0xDF;
      i++;  
    }
    com_string[i] = '\0';
    if ((i != len) && (*str != SPACE)) {
      invalid = 1;
    }
    len -= i;
    if (!invalid) {
      /* find string in remote-command-list */
      found = 0;
      j = 0;
      while ((remote_list[j].ext_com != -1) && !found) {
        if (strstr(remote_list[j].string,com_string)
            == remote_list[j].string) {
          /* string found, now check if length valid */
          if (strlen(com_string) >= remote_list[j].len) {
            found = 1;
          }
        }
        if (!found) j++;
      }
      if (found) {
        /* delete spaces before parameters */
        while (*str == SPACE) {
          str++;
          len--;
        }
        if (remote_list[j].ext_com == 2) result = 1;
        if (remote_list[j].ext_com) {
          (*remote_list[j].func) (remote_list[j].par1,remote_list[j].par2,
                                  channel,len,M_REMOTE,str);
        }
        continue;
      }
    }
    strcpy(str,rem_tnt_str);
    strcat(str,rem_inv_str);
    strcat(str,rem_newlin_str);
    len = strlen(str);
    flag = 0;
    rem_data_display(channel,str);
    queue_cmd_data(channel,X_DATA,len,flag,str);
  }
  return(result);
}

static void rem_echo(par1,par2,channel,len,mode,str)
int par1;
int par2;
int channel;
int len;
int mode;
char *str;
{
  int flag;
  char ans_str[256];
  int ans_len;
  
  flag = 0;
  strcpy(ans_str,str);
  strcat(ans_str,rem_newlin_str);
  ans_len = strlen(ans_str);
  rem_data_display(channel,ans_str);
  queue_cmd_data(channel,X_DATA,ans_len,flag,ans_str);
}

static void rem_version(par1,par2,channel,len,mode,str)
int par1;
int par2;
int channel;
int len;
int mode;
char *str;
{
  int flag;
  char ans_str[80];
  int ans_len;
  
  flag = 0;
  strcpy(ans_str,rem_tnt_str);
  strcat(ans_str,rem_ver_str);
  strcat(ans_str,rem_newlin_str);
  ans_len = strlen(ans_str);
  rem_data_display(channel,ans_str);
  queue_cmd_data(channel,X_DATA,ans_len,flag,ans_str);
}

void rem_time(par1,par2,channel,len,mode,str)
int par1;
int par2;
int channel;
int len;
int mode;
char *str;
{
  struct tm timestr;
  time_t timeval;
  char tmpstr[40];
  char ans_str[80];
  int ans_len;
  int flag;
  
  timeval = time(&timeval);
  timestr = *localtime(&timeval);
  sprintf(tmpstr,"%2.2u/%2.2u/%2.2u %2.2u:%2.2u:%2.2u",
          timestr.tm_year,timestr.tm_mon+1,timestr.tm_mday,
          timestr.tm_hour,timestr.tm_min,timestr.tm_sec);
  flag = 0;
  strcpy(ans_str,rem_tnt_str);
  strcat(ans_str,tmpstr);
  strcat(ans_str,rem_newlin_str);
  ans_len = strlen(ans_str);
  rem_data_display(channel,ans_str);
  queue_cmd_data(channel,X_DATA,ans_len,flag,ans_str);
}

static void rem_disc(par1,par2,channel,len,mode,str)
int par1;
int par2;
int channel;
int len;
int mode;
char *str;
{
  int flag;
  char ans_str[10];
  int ans_len;
  
  flag = 0;
  ans_len = strlen(rem_dis_str);
  rem_data_display(channel,rem_dis_str);
  queue_cmd_data(channel,X_DATA,ans_len,flag,rem_dis_str);
  strcpy(ans_str,"D");
  ans_len = strlen(ans_str);
  queue_cmd_data(channel,X_COMM,ans_len,M_CMDSCRIPT,ans_str);
}

static void rem_info(par1,par2,channel,len,mode,str)
int par1;
int par2;
int channel;
int len;
int mode;
char *str;
{
  int x_par1,x_par2;
  char ans_str[160];
  int ans_len;

  strcpy(ans_str,tnt_dir);
  strcat(ans_str,rem_info_file);  
  ans_len = strlen(ans_str);
  x_par1 = TX_NORM;
  x_par2 = 1;
  open_sendfile(x_par1,x_par2,channel,ans_len,mode,ans_str);
}

static void rem_help(par1,par2,channel,len,mode,str)
int par1;
int par2;
int channel;
int len;
int mode;
char *str;
{
  int x_par1,x_par2;
  char ans_str[160];
  int ans_len;

  strcpy(ans_str,tnt_dir);
  strcat(ans_str,rem_help_file);  
  ans_len = strlen(ans_str);
  x_par1 = TX_NORM;
  x_par2 = 1;
  open_sendfile(x_par1,x_par2,channel,ans_len,mode,ans_str);
}

static void rem_news(par1,par2,channel,len,mode,str)
int par1;
int par2;
int channel;
int len;
int mode;
char *str;
{
  int x_par1,x_par2;
  char ans_str[160];
  int ans_len;

  strcpy(ans_str,tnt_dir);
  strcat(ans_str,news_file_name);  
  ans_len = strlen(ans_str);
  x_par1 = TX_NORM;
  x_par2 = 1;
  open_sendfile(x_par1,x_par2,channel,ans_len,mode,ans_str);
}

void rem_dir(par1,par2,channel,len,mode,str)
int par1;
int par2;
int channel;
int len;
int mode;
char *str;
{
  int x_par1;
  int ans_len;
  char string[80];
  char tmpname[20];
  int result;
  int uid,gid;

#ifdef HAS_INDEX
  if (index(str,'/') != NULL) {
#else
  if (strchr(str,'/') != NULL) {
#endif
    cmd_display(mode,channel,rem_nodir_str,1);
  }
  strcpy(tmpname,"/tmp/tntdirXXXXXX");
  mktemp(tmpname);
  if (par2)
    strcpy(string,DIRRUN_STRING);
  else if (par1)   
    strcpy(string,DIRL_STRING);
  else
    strcpy(string,DIR_STRING);
  if (par2)
    strcat(string,run_dir);
  else
    strcat(string,remote_dir);
  strcat(string,str);
  strcat(string," >");
  strcat(string,tmpname);
  strcat(string," 2>/dev/null");
  drop_priv(mode,channel,&uid,&gid);
  result = system(string);
  rest_priv(mode,channel,uid,gid);
  if (!result) {
    ans_len = strlen(tmpname);
    x_par1 = TX_NORM;
    open_sendfile(x_par1,par2,channel,ans_len,M_REMOTE_TEMP,tmpname);
  }
  else {
    unlink(tmpname);
    cmd_display(mode,channel,rem_nodir_str,1);
  }
}

static void rem_free(par1,par2,channel,len,mode,str)
int par1;
int par2;
int channel;
int len;
int mode;
char *str;
{
  int x_par1;
  int ans_len;
  char string[80];
  char tmpname[20];
  int result;

  strcpy(tmpname,"/tmp/tntfreXXXXXX");
  mktemp(tmpname);
  strcpy(string,FREE_STRING);
  strcat(string,tmpname);
  result = system(string);
  if (!result) {
    ans_len = strlen(tmpname);
    x_par1 = TX_NORM;
    open_sendfile(x_par1,par2,channel,ans_len,M_REMOTE_TEMP,tmpname);
  }
  else {
    unlink(tmpname);
    cmd_display(mode,channel,rem_error_str,1);
  }
}

/* send one cookie */
/* if par1 != 0: header and footer output */
void rem_cookie(par1,par2,channel,len,mode,str)
int par1;
int par2;
int channel;
int len;
int mode;
char *str;
{
  int x_par1;
  int ans_len;
  char tmpname[20];
  int result;
  
  strcpy(tmpname,"/tmp/tntcooXXXXXX");
  mktemp(tmpname);
  result = gen_cookie(tmpname,par1);
  if (!result) {
    ans_len = strlen(tmpname);
    x_par1 = TX_NORM;
    open_sendfile(x_par1,par2,channel,ans_len,M_REMOTE_TEMP,tmpname);
  }
  else {
    unlink(tmpname);
    if (result == 1)
      cmd_display(mode,channel,rem_nocook_str,1);
    else
      cmd_display(mode,channel,rem_error_str,1);
  }
}

/* put callsign of remote station on channel to call */
/* call of station to which physically connected (AX25) */
void strip_call(call,channel)
char call[];
int channel;
{
  int i;
  int offset;
   
  offset = 0; 
  if (ch_stat[channel].call[1] == ':') {
    offset = 2;
  }  
  for (i = 0; i < 9; i++) {
    call[i] = ch_stat[channel].call[i+offset];
    if (call[i] == '\0') {
      break;
    }
    if (call[i] == ' ') {
      call[i] = '\0';
      break;
    } 
  }
  if (i == 9) call[i] = '\0';
}

/* put callsign of remote station on channel to call */
/* call of station to which logically connected (DIGIPEATER) */
void strip_call_log(call,channel)
char call[];
int channel;
{
  int i;
  int offset;
  char *colon;

  if (ch_stat[channel].disp_call[0] == '\0') {
    strip_call(call,channel);
    return;
  }   
  offset = 0;
  colon = strchr(ch_stat[channel].disp_call,':');
  if (colon != NULL) {
    offset = colon + 1 - ch_stat[channel].disp_call; 
  }  
  for (i = 0; i < 9; i++) {
    call[i] = toupper(ch_stat[channel].disp_call[i+offset]);
    if (call[i] == '\0') {
      break;
    }
    if (call[i] == ' ') {
      call[i] = '\0';
      break;
    } 
  }
  if (i == 9) call[i] = '\0';
}

/* send the ctext */
void rem_ctext(par1,par2,channel,len,mode,str)
int par1;
int par2;
int channel;
int len;
int mode;
char *str;
{
  int x_par1;
  int ans_len;
  char string[160];
  char tmpname[20];
  int result;
  int fd1;
  int fd2;
  char call[10];
  char call2[10];
  int i;
  int end;

  strcpy(tmpname,"/tmp/tntctxXXXXXX");
  mktemp(tmpname);

  strip_call(call,channel);
  i = 0;
  end = 0;
  do {
    if ((call2[i] = tolower(call[i])) == '-') {
      call2[i] = '\0';
      end = 1;
    }
    i++;
  } while ((i <= 9) && (!end));

  strcpy(string,ctext_dir);
  strcat(string,call2);
  strcat(string,".ctx");
  fd1 = open(string,O_RDONLY);
  if (fd1 < 0) {
    strcpy(string,tnt_dir);
    strcat(string,tnt_ctextfile);
    fd1 = open(string,O_RDONLY);
    if(fd1 < 0) return;
  }

  fd2 = open(tmpname,O_RDWR|O_CREAT,PMODE);
  if(fd2 < 0) { close(fd1); return; }

  result = replace_macros(fd1,fd2,call,
                          ch_stat[channel].curcall,channel);

  close(fd1);
  close(fd2);

  if (result > 0) {
    ans_len = strlen(tmpname);
    x_par1 = TX_NORM;
    open_sendfile(x_par1,par2,channel,ans_len,M_REMOTE_TEMP,tmpname);
  }
  else {
    unlink(tmpname);
    if (result == 1)
      cmd_display(mode,channel,rem_nocook_str,1);
    else
      cmd_display(mode,channel,rem_error_str,1);
  }
}

/* update names file */
void rem_name(par1,par2,channel,len,mode,str)
int par1;
int par2;
int channel;
int len;
int mode;
char *str;
{
  char call[9];
  char tempstr[250];
  int fd;
  char namestr[90];

  if (ch_stat[channel].state < 4) {
    cmd_display(mode,channel,"Only while connected",1);
    return;
  }
  strcpy(tempstr,tnt_dir);
  strcat(tempstr,name_file_name);  
  strip_call_log(call,channel);
  if (len == 0) { /* no name specified */
    if (macro_getname(tempstr,call,namestr) == TNT_OK) {
      cmd_display(mode,channel,namestr,1);
      return;
    }
    else {
      cmd_display(mode,channel,"No access to names database",1);
      return;
    }
  }
  /* test if entry in namesfile */
  if (find_line_for_call(tempstr,call,namestr) == LINE_FOUND) {
    if (delete_line_for_call(tempstr,call) > 0) {
      cmd_display(mode,channel,rem_name_err,1);
      return;
    }
  }
  fd = open(tempstr,O_RDWR|O_APPEND|O_CREAT,PMODE);
  if (fd < 0) {  
    cmd_display(mode,channel,rem_name_err,1);
    return;
  }
  sprintf(tempstr,"T>%s %.50s\n",call,str);
  if (write(fd,tempstr,strlen(tempstr)) < strlen(tempstr)) {
    cmd_display(mode,channel,rem_name_err,1);
    close(fd);
    return;
  }
  close(fd);
  if (mode == M_REMOTE) {
    strcpy(tempstr,rem_name_str1);
    strcat(tempstr,str);
    strcat(tempstr,rem_name_str2);
    cmd_display(mode,channel,tempstr,1);
  }
  else {
    cmd_display(mode,channel,"Ok",1);
  }
}

/* send a macro-textfile */
void cmd_msend(par1,par2,channel,len,mode,str)
int par1;
int par2;
int channel;
int len;
int mode;
char *str;
{
  int x_par1;
  int ans_len;
  char string[160];
  char tmpname[20];
  int result;
  int fd1;
  int fd2;
  int i;
  int end;
  char call[10];

  strcpy(tmpname,"/tmp/tntmtxXXXXXX");
  mktemp(tmpname);

#ifdef HAS_INDEX
  if (index(str,'/') != NULL) {
#else
  if (strchr(str,'/') != NULL) {
#endif
    strcpy(string,str);
  }
  else {
    strcpy(string,macrotext_dir);
    strcat(string,str);
  }
  fd1 = open(string,O_RDONLY);
  if (fd1 < 0) {
    cmd_display(mode,channel,"Can't open file",1);
    return;
  }

  fd2 = open(tmpname,O_RDWR|O_CREAT,PMODE);
  if(fd2 < 0) { close(fd1); return; }

  strip_call_log(call,channel);
  result = replace_macros(fd1,fd2,call,
                          ch_stat[channel].curcall,channel);

  close(fd1);
  close(fd2);

  if (result > 0) {
    ans_len = strlen(tmpname);
    x_par1 = TX_NORM;
    open_sendfile(x_par1,par2,channel,ans_len,M_REMOTE_TEMP,tmpname);
    cmd_display(mode,channel,ok_text,1);
  }
  else {
    unlink(tmpname);
    if (result == 1)
      cmd_display(mode,channel,rem_nocook_str,1);
    else
      cmd_display(mode,channel,rem_error_str,1);
  }
}

